gtkmm: Gtk::SymbolicPaintable Class Reference

gtkmm 4.12.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::SymbolicPaintable Class Reference

An interface that supports symbolic colors in paintables. More...

`#include <gtkmm/symbolicpaintable.h>`

Inheritance diagram for Gtk::SymbolicPaintable:
[legend]

## Public Member Functions
| SymbolicPaintable (SymbolicPaintable && src) noexcept
SymbolicPaintable & | operator= (SymbolicPaintable && src) noexcept
| ~SymbolicPaintable () noexcept override
GtkSymbolicPaintable * | gobj ()
| Provides access to the underlying C GObject.
const GtkSymbolicPaintable * | gobj () const
| Provides access to the underlying C GObject.
void | snapshot_symbolic (const Glib::RefPtr< Gdk::Snapshot > & snapshot, double width, double height, const std::vector< Gdk::RGBA > & colors)
| Snapshots the paintable with the given colors.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| SymbolicPaintable ()
| You should derive from this class to use it.
virtual void | snapshot_symbolic_vfunc (const Glib::RefPtr< Gdk::Snapshot > & snapshot, double width, double height, const std::vector< Gdk::RGBA > & colors)
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::SymbolicPaintable > | wrap (GtkSymbolicPaintable * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

An interface that supports symbolic colors in paintables.

Gdk::Paintables implementing the interface will have the snapshot_symbolic_vfunc() function called and have the colors for drawing symbolic icons passed. At least 4 colors are guaranteed to be passed every time.

These 4 colors are the foreground color, and the colors to use for errors, warnings and success information in that order.

More colors may be added in the future.

Since gtkmm 4.12:

## Constructor & Destructor Documentation

## ◆ SymbolicPaintable() [1/2]

Gtk::SymbolicPaintable::SymbolicPaintable | ( |  | ) |
| protected

You should derive from this class to use it.

## ◆ SymbolicPaintable() [2/2]

Gtk::SymbolicPaintable::SymbolicPaintable | ( | SymbolicPaintable && | src | ) |
| noexcept

## ◆ ~SymbolicPaintable()

Gtk::SymbolicPaintable::~SymbolicPaintable | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ add_interface()

static void Gtk::SymbolicPaintable::add_interface | ( | GType | gtype_implementer | ) |
| static

## ◆ get_type()

static GType Gtk::SymbolicPaintable::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkSymbolicPaintable * Gtk::SymbolicPaintable::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkSymbolicPaintable * Gtk::SymbolicPaintable::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=()

SymbolicPaintable & Gtk::SymbolicPaintable::operator= | ( | SymbolicPaintable && | src | ) |
| noexcept

## ◆ snapshot_symbolic()

void Gtk::SymbolicPaintable::snapshot_symbolic | ( | const Glib::RefPtr< Gdk::Snapshot > & | snapshot,
|  | double | width,
|  | double | height,
|  | const std::vector< Gdk::RGBA > & | colors
| ) |  |

Snapshots the paintable with the given colors.

If less than 4 colors are provided, GTK will pad the vector with default colors.

Since gtkmm 4.12:

Parameters

  snapshot | A Gdk::Snapshot to snapshot to.
  width | Width to snapshot in.
  height | Height to snapshot in.
  colors | A vector of colors.

## ◆ snapshot_symbolic_vfunc()

virtual void Gtk::SymbolicPaintable::snapshot_symbolic_vfunc | ( | const Glib::RefPtr< Gdk::Snapshot > & | snapshot,
|  | double | width,
|  | double | height,
|  | const std::vector< Gdk::RGBA > & | colors
| ) |  |
| protectedvirtual

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::SymbolicPaintable > wrap | ( | GtkSymbolicPaintable * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.